Index: trunk/src/org/openstreetmap/josm/io/DefaultProxySelector.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/DefaultProxySelector.java	(revision 12523)
+++ trunk/src/org/openstreetmap/josm/io/DefaultProxySelector.java	(revision 12537)
@@ -41,9 +41,9 @@
      * We therefore read the property at class loading time and remember it's value.
      */
-    private static boolean JVM_WILL_USE_SYSTEM_PROXIES;
+    private static boolean jvmWillUseSystemProxies;
     static {
         String v = System.getProperty("java.net.useSystemProxies");
         if (v != null && v.equals(Boolean.TRUE.toString())) {
-            JVM_WILL_USE_SYSTEM_PROXIES = true;
+            jvmWillUseSystemProxies = true;
         }
     }
@@ -59,5 +59,5 @@
      */
     public static boolean willJvmRetrieveSystemProxies() {
-        return JVM_WILL_USE_SYSTEM_PROXIES;
+        return jvmWillUseSystemProxies;
     }
 
@@ -202,5 +202,5 @@
         switch(proxyPolicy) {
         case USE_SYSTEM_SETTINGS:
-            if (!JVM_WILL_USE_SYSTEM_PROXIES) {
+            if (!jvmWillUseSystemProxies) {
                 Main.warn(tr("The JVM is not configured to lookup proxies from the system settings. "+
                         "The property ''java.net.useSystemProxies'' was missing at startup time.  Will not use a proxy."));
Index: trunk/src/org/openstreetmap/josm/io/GeoJSONWriter.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/GeoJSONWriter.java	(revision 12523)
+++ trunk/src/org/openstreetmap/josm/io/GeoJSONWriter.java	(revision 12537)
@@ -45,5 +45,5 @@
     private final OsmDataLayer layer;
     private final Projection projection;
-    private static final boolean skipEmptyNodes = true;
+    private static final boolean SKIP_EMPTY_NODES = true;
 
     /**
@@ -165,5 +165,5 @@
         if (p.isIncomplete()) {
             return;
-        } else if (skipEmptyNodes && p instanceof Node && p.getKeys().isEmpty()) {
+        } else if (SKIP_EMPTY_NODES && p instanceof Node && p.getKeys().isEmpty()) {
             return;
         }
Index: trunk/src/org/openstreetmap/josm/io/OverpassDownloadReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OverpassDownloadReader.java	(revision 12523)
+++ trunk/src/org/openstreetmap/josm/io/OverpassDownloadReader.java	(revision 12537)
@@ -99,5 +99,5 @@
     static final Pattern OUTPUT_FORMAT_STATEMENT = Pattern.compile(".*\\[out:([a-z]{3,})\\].*", Pattern.DOTALL);
 
-    static final Map<OverpassOutpoutFormat, Class<? extends AbstractReader>> outputFormatReaders = new ConcurrentHashMap<>();
+    static final Map<OverpassOutpoutFormat, Class<? extends AbstractReader>> OUTPUT_FORMAT_READERS = new ConcurrentHashMap<>();
 
     final String overpassServer;
@@ -125,5 +125,5 @@
     public static final Class<? extends AbstractReader> registerOverpassOutpoutFormatReader(
             OverpassOutpoutFormat format, Class<? extends AbstractReader> readerClass) {
-        return outputFormatReaders.put(Objects.requireNonNull(format), Objects.requireNonNull(readerClass));
+        return OUTPUT_FORMAT_READERS.put(Objects.requireNonNull(format), Objects.requireNonNull(readerClass));
     }
 
@@ -232,5 +232,5 @@
         Matcher m = OUTPUT_FORMAT_STATEMENT.matcher(overpassQuery);
         if (m.matches()) {
-            Class<? extends AbstractReader> readerClass = outputFormatReaders.get(OverpassOutpoutFormat.from(m.group(1)));
+            Class<? extends AbstractReader> readerClass = OUTPUT_FORMAT_READERS.get(OverpassOutpoutFormat.from(m.group(1)));
             if (readerClass != null) {
                 try {
Index: trunk/src/org/openstreetmap/josm/io/XmlWriter.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/XmlWriter.java	(revision 12523)
+++ trunk/src/org/openstreetmap/josm/io/XmlWriter.java	(revision 12537)
@@ -62,5 +62,5 @@
                 String encS = null;
                 if (!keepApos || unencoded.charAt(i) != '\'') {
-                    encS = XmlWriter.encoding.get(unencoded.charAt(i));
+                    encS = ENCODING.get(unencoded.charAt(i));
                 }
                 if (encS != null) {
@@ -80,14 +80,14 @@
      * The output writer to save the values to.
      */
-    private static final Map<Character, String> encoding = new HashMap<>();
+    private static final Map<Character, String> ENCODING = new HashMap<>();
     static {
-        encoding.put('<', "&lt;");
-        encoding.put('>', "&gt;");
-        encoding.put('"', "&quot;");
-        encoding.put('\'', "&apos;");
-        encoding.put('&', "&amp;");
-        encoding.put('\n', "&#xA;");
-        encoding.put('\r', "&#xD;");
-        encoding.put('\t', "&#x9;");
+        ENCODING.put('<', "&lt;");
+        ENCODING.put('>', "&gt;");
+        ENCODING.put('"', "&quot;");
+        ENCODING.put('\'', "&apos;");
+        ENCODING.put('&', "&amp;");
+        ENCODING.put('\n', "&#xA;");
+        ENCODING.put('\r', "&#xD;");
+        ENCODING.put('\t', "&#x9;");
     }
 
Index: trunk/src/org/openstreetmap/josm/io/remotecontrol/AddTagsDialog.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/remotecontrol/AddTagsDialog.java	(revision 12523)
+++ trunk/src/org/openstreetmap/josm/io/remotecontrol/AddTagsDialog.java	(revision 12537)
@@ -51,5 +51,5 @@
 
     private final String sender;
-    private static final Set<String> trustedSenders = new HashSet<>();
+    private static final Set<String> TRUSTED_SENDERS = new HashSet<>();
 
     static final class PropertyTableModel extends DefaultTableModel {
@@ -227,12 +227,12 @@
         tablePanel.add(propertyTable.getTableHeader(), GBC.eol().fill(GBC.HORIZONTAL));
         tablePanel.add(propertyTable, GBC.eol().fill(GBC.BOTH));
-        if (!sender.isEmpty() && !trustedSenders.contains(sender)) {
+        if (!sender.isEmpty() && !TRUSTED_SENDERS.contains(sender)) {
             final JCheckBox c = new JCheckBox();
             c.setAction(new AbstractAction(tr("Accept all tags from {0} for this session", sender)) {
                 @Override public void actionPerformed(ActionEvent e) {
                     if (c.isSelected())
-                        trustedSenders.add(sender);
+                        TRUSTED_SENDERS.add(sender);
                     else
-                        trustedSenders.remove(sender);
+                        TRUSTED_SENDERS.remove(sender);
                 }
             });
@@ -263,5 +263,5 @@
         }
         if (buttonIndex == 2) {
-            trustedSenders.remove(sender);
+            TRUSTED_SENDERS.remove(sender);
         }
         setVisible(false);
@@ -308,5 +308,5 @@
      */
     public static void addTags(String[][] keyValue, String sender, Collection<? extends OsmPrimitive> primitives) {
-        if (trustedSenders.contains(sender)) {
+        if (TRUSTED_SENDERS.contains(sender)) {
             if (Main.getLayerManager().getEditDataSet() != null) {
                 for (String[] row : keyValue) {
Index: trunk/src/org/openstreetmap/josm/io/session/SessionReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/session/SessionReader.java	(revision 12523)
+++ trunk/src/org/openstreetmap/josm/io/session/SessionReader.java	(revision 12537)
@@ -147,5 +147,5 @@
     }
 
-    private static final Map<String, Class<? extends SessionLayerImporter>> sessionLayerImporters = new HashMap<>();
+    private static final Map<String, Class<? extends SessionLayerImporter>> SESSION_LAYER_IMPORTERS = new HashMap<>();
 
     private URI sessionFileURI;
@@ -174,5 +174,5 @@
      */
     public static void registerSessionLayerImporter(String layerType, Class<? extends SessionLayerImporter> importer) {
-        sessionLayerImporters.put(layerType, importer);
+        SESSION_LAYER_IMPORTERS.put(layerType, importer);
     }
 
@@ -183,5 +183,5 @@
      */
     public static SessionLayerImporter getSessionLayerImporter(String layerType) {
-        Class<? extends SessionLayerImporter> importerClass = sessionLayerImporters.get(layerType);
+        Class<? extends SessionLayerImporter> importerClass = SESSION_LAYER_IMPORTERS.get(layerType);
         if (importerClass == null)
             return null;