Index: trunk/src/org/openstreetmap/josm/data/SystemOfMeasurement.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/SystemOfMeasurement.java	(revision 12540)
+++ trunk/src/org/openstreetmap/josm/data/SystemOfMeasurement.java	(revision 12542)
@@ -80,5 +80,5 @@
     }
 
-    private static final CopyOnWriteArrayList<SoMChangeListener> SOM_CHANGE_LISTENERS = new CopyOnWriteArrayList<>();
+    private static final CopyOnWriteArrayList<SoMChangeListener> somChangeListeners = new CopyOnWriteArrayList<>();
 
     /**
@@ -89,5 +89,5 @@
      */
     public static void removeSoMChangeListener(SoMChangeListener listener) {
-        SOM_CHANGE_LISTENERS.remove(listener);
+        somChangeListeners.remove(listener);
     }
 
@@ -100,10 +100,10 @@
     public static void addSoMChangeListener(SoMChangeListener listener) {
         if (listener != null) {
-            SOM_CHANGE_LISTENERS.addIfAbsent(listener);
+            somChangeListeners.addIfAbsent(listener);
         }
     }
 
     protected static void fireSoMChanged(String oldSoM, String newSoM) {
-        for (SoMChangeListener l : SOM_CHANGE_LISTENERS) {
+        for (SoMChangeListener l : somChangeListeners) {
             l.systemOfMeasurementChanged(oldSoM, newSoM);
         }
Index: trunk/src/org/openstreetmap/josm/data/cache/JCSCachedTileLoaderJob.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/cache/JCSCachedTileLoaderJob.java	(revision 12540)
+++ trunk/src/org/openstreetmap/josm/data/cache/JCSCachedTileLoaderJob.java	(revision 12542)
@@ -81,6 +81,6 @@
 
 
-    private static final ConcurrentMap<String, Set<ICachedLoaderListener>> IN_PROGRESS = new ConcurrentHashMap<>();
-    private static final ConcurrentMap<String, Boolean> USE_HEAD = new ConcurrentHashMap<>();
+    private static final ConcurrentMap<String, Set<ICachedLoaderListener>> inProgress = new ConcurrentHashMap<>();
+    private static final ConcurrentMap<String, Boolean> useHead = new ConcurrentHashMap<>();
 
     protected final long now; // when the job started
@@ -162,9 +162,9 @@
             throw new IllegalArgumentException("No url returned");
         }
-        synchronized (IN_PROGRESS) {
-            Set<ICachedLoaderListener> newListeners = IN_PROGRESS.get(deduplicationKey);
+        synchronized (inProgress) {
+            Set<ICachedLoaderListener> newListeners = inProgress.get(deduplicationKey);
             if (newListeners == null) {
                 newListeners = new HashSet<>();
-                IN_PROGRESS.put(deduplicationKey, newListeners);
+                inProgress.put(deduplicationKey, newListeners);
                 first = true;
             }
@@ -259,7 +259,7 @@
     private void finishLoading(LoadResult result) {
         Set<ICachedLoaderListener> listeners;
-        synchronized (IN_PROGRESS) {
+        synchronized (inProgress) {
             try {
-                listeners = IN_PROGRESS.remove(getUrl().toString());
+                listeners = inProgress.remove(getUrl().toString());
             } catch (IOException e) {
                 listeners = null;
@@ -312,5 +312,5 @@
             // then just use HEAD request and check returned values
             if (isObjectLoadable() &&
-                    Boolean.TRUE.equals(USE_HEAD.get(getServerKey())) &&
+                    Boolean.TRUE.equals(useHead.get(getServerKey())) &&
                     isCacheValidUsingHead()) {
                 LOG.log(Level.FINE, "JCS - cache entry verified using HEAD request: {0}", getUrl());
@@ -346,5 +346,5 @@
                 LOG.log(Level.INFO, "JCS - Host: {0} found not to return 304 codes for If-Modified-Since or If-None-Match headers",
                         serverKey);
-                USE_HEAD.put(serverKey, Boolean.TRUE);
+                useHead.put(serverKey, Boolean.TRUE);
             }
 
Index: trunk/src/org/openstreetmap/josm/data/imagery/TMSCachedTileLoaderJob.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/imagery/TMSCachedTileLoaderJob.java	(revision 12540)
+++ trunk/src/org/openstreetmap/josm/data/imagery/TMSCachedTileLoaderJob.java	(revision 12542)
@@ -51,5 +51,5 @@
     // we need another deduplication of Tile Loader listeners, as for each submit, new TMSCachedTileLoaderJob was created
     // that way, we reduce calls to tileLoadingFinished, and general CPU load due to surplus Map repaints
-    private static final ConcurrentMap<String, Set<TileLoaderListener>> IN_PROGRESS = new ConcurrentHashMap<>();
+    private static final ConcurrentMap<String, Set<TileLoaderListener>> inProgress = new ConcurrentHashMap<>();
 
     /**
@@ -71,9 +71,9 @@
         if (listener != null) {
             String deduplicationKey = getCacheKey();
-            synchronized (IN_PROGRESS) {
-                Set<TileLoaderListener> newListeners = IN_PROGRESS.get(deduplicationKey);
+            synchronized (inProgress) {
+                Set<TileLoaderListener> newListeners = inProgress.get(deduplicationKey);
                 if (newListeners == null) {
                     newListeners = new HashSet<>();
-                    IN_PROGRESS.put(deduplicationKey, newListeners);
+                    inProgress.put(deduplicationKey, newListeners);
                 }
                 newListeners.add(listener);
@@ -162,6 +162,6 @@
         this.attributes = attributes; // as we might get notification from other object than our selfs, pass attributes along
         Set<TileLoaderListener> listeners;
-        synchronized (IN_PROGRESS) {
-            listeners = IN_PROGRESS.remove(getCacheKey());
+        synchronized (inProgress) {
+            listeners = inProgress.remove(getCacheKey());
         }
         boolean status = result.equals(LoadResult.SUCCESS);
Index: trunk/src/org/openstreetmap/josm/data/osm/AbstractPrimitive.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/osm/AbstractPrimitive.java	(revision 12540)
+++ trunk/src/org/openstreetmap/josm/data/osm/AbstractPrimitive.java	(revision 12542)
@@ -47,5 +47,5 @@
     }
 
-    private static final AtomicLong ID_COUNTER = new AtomicLong(0);
+    private static final AtomicLong idCounter = new AtomicLong(0);
 
     /**
@@ -54,5 +54,5 @@
      */
     static long generateUniqueId() {
-        return ID_COUNTER.decrementAndGet();
+        return idCounter.decrementAndGet();
     }
 
@@ -63,5 +63,5 @@
      */
     public static long currentUniqueId() {
-        return ID_COUNTER.get();
+        return idCounter.get();
     }
 
@@ -76,5 +76,5 @@
             throw new IllegalArgumentException("Cannot modify the id counter backwards");
         }
-        ID_COUNTER.set(newId);
+        idCounter.set(newId);
     }
 
Index: trunk/src/org/openstreetmap/josm/data/osm/DataSet.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/osm/DataSet.java	(revision 12540)
+++ trunk/src/org/openstreetmap/josm/data/osm/DataSet.java	(revision 12542)
@@ -638,5 +638,5 @@
      * dataset. (However, the selection does only change in the active layer)
      */
-    private static final Collection<SelectionChangedListener> SEL_LISTENERS = new CopyOnWriteArrayList<>();
+    private static final Collection<SelectionChangedListener> selListeners = new CopyOnWriteArrayList<>();
 
     /**
@@ -647,5 +647,5 @@
      */
     public static void addSelectionListener(SelectionChangedListener listener) {
-        ((CopyOnWriteArrayList<SelectionChangedListener>) SEL_LISTENERS).addIfAbsent(listener);
+        ((CopyOnWriteArrayList<SelectionChangedListener>) selListeners).addIfAbsent(listener);
     }
 
@@ -657,5 +657,5 @@
      */
     public static void removeSelectionListener(SelectionChangedListener listener) {
-        SEL_LISTENERS.remove(listener);
+        selListeners.remove(listener);
     }
 
@@ -671,5 +671,5 @@
 
     private static void fireDreprecatedSelectionChange(Collection<? extends OsmPrimitive> currentSelection) {
-        for (SelectionChangedListener l : SEL_LISTENERS) {
+        for (SelectionChangedListener l : selListeners) {
             l.selectionChanged(currentSelection);
         }
Index: trunk/src/org/openstreetmap/josm/data/validation/OsmValidator.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/validation/OsmValidator.java	(revision 12540)
+++ trunk/src/org/openstreetmap/josm/data/validation/OsmValidator.java	(revision 12542)
@@ -79,11 +79,11 @@
     private static double griddetail;
 
-    private static final Collection<String> IGNORED_ERRORS = new TreeSet<>();
+    private static final Collection<String> ignoredErrors = new TreeSet<>();
 
     /**
      * All registered tests
      */
-    private static final Collection<Class<? extends Test>> ALL_TESTS = new ArrayList<>();
-    private static final Map<String, Test> ALL_TESTS_MAP = new HashMap<>();
+    private static final Collection<Class<? extends Test>> allTests = new ArrayList<>();
+    private static final Map<String, Test> allTestsMap = new HashMap<>();
 
     /**
@@ -139,7 +139,7 @@
      */
     public static void addTest(Class<? extends Test> testClass) {
-        ALL_TESTS.add(testClass);
+        allTests.add(testClass);
         try {
-            ALL_TESTS_MAP.put(testClass.getName(), testClass.getConstructor().newInstance());
+            allTestsMap.put(testClass.getName(), testClass.getConstructor().newInstance());
         } catch (ReflectiveOperationException e) {
             Main.error(e);
@@ -182,10 +182,10 @@
 
     private static void loadIgnoredErrors() {
-        IGNORED_ERRORS.clear();
+        ignoredErrors.clear();
         if (ValidatorPreference.PREF_USE_IGNORE.get()) {
             Path path = Paths.get(getValidatorDir()).resolve("ignorederrors");
             if (path.toFile().exists()) {
                 try {
-                    IGNORED_ERRORS.addAll(Files.readAllLines(path, StandardCharsets.UTF_8));
+                    ignoredErrors.addAll(Files.readAllLines(path, StandardCharsets.UTF_8));
                 } catch (final FileNotFoundException e) {
                     Main.debug(Main.getErrorMessage(e));
@@ -204,5 +204,5 @@
      */
     public static void addIgnoredError(String s) {
-        IGNORED_ERRORS.add(s);
+        ignoredErrors.add(s);
     }
 
@@ -213,5 +213,5 @@
      */
     public static boolean hasIgnoredError(String s) {
-        return IGNORED_ERRORS.contains(s);
+        return ignoredErrors.contains(s);
     }
 
@@ -221,5 +221,5 @@
     public static void saveIgnoredErrors() {
         try (PrintWriter out = new PrintWriter(new File(getValidatorDir(), "ignorederrors"), StandardCharsets.UTF_8.name())) {
-            for (String e : IGNORED_ERRORS) {
+            for (String e : ignoredErrors) {
                 out.println(e);
             }
@@ -254,7 +254,7 @@
      */
     public static SortedMap<String, Test> getAllTestsMap() {
-        applyPrefs(ALL_TESTS_MAP, false);
-        applyPrefs(ALL_TESTS_MAP, true);
-        return new TreeMap<>(ALL_TESTS_MAP);
+        applyPrefs(allTestsMap, false);
+        applyPrefs(allTestsMap, true);
+        return new TreeMap<>(allTestsMap);
     }
 
@@ -271,5 +271,5 @@
             return null;
         }
-        return (T) ALL_TESTS_MAP.get(testClass.getName());
+        return (T) allTestsMap.get(testClass.getName());
     }
 
@@ -318,5 +318,5 @@
      */
     public static Collection<Class<? extends Test>> getAllAvailableTestClasses() {
-        return Collections.unmodifiableCollection(ALL_TESTS);
+        return Collections.unmodifiableCollection(allTests);
     }
 