Index: trunk/src/org/openstreetmap/josm/actions/AutoScaleAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/AutoScaleAction.java	(revision 12637)
+++ trunk/src/org/openstreetmap/josm/actions/AutoScaleAction.java	(revision 12639)
@@ -394,5 +394,5 @@
         //
         MapView.addZoomChangeListener(new ZoomChangeAdapter());
-        Main.addMapFrameListener(new MapFrameAdapter());
+        MainApplication.addMapFrameListener(new MapFrameAdapter());
         initEnabledState();
     }
Index: trunk/src/org/openstreetmap/josm/actions/CopyAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/CopyAction.java	(revision 12637)
+++ trunk/src/org/openstreetmap/josm/actions/CopyAction.java	(revision 12639)
@@ -16,4 +16,5 @@
 import org.openstreetmap.josm.data.osm.DataSet;
 import org.openstreetmap.josm.data.osm.OsmPrimitive;
+import org.openstreetmap.josm.gui.MainApplication;
 import org.openstreetmap.josm.gui.datatransfer.ClipboardUtils;
 import org.openstreetmap.josm.gui.datatransfer.PrimitiveTransferable;
@@ -36,5 +37,5 @@
         putValue("help", ht("/Action/Copy"));
         // CUA shortcut for copy (https://en.wikipedia.org/wiki/IBM_Common_User_Access#Description)
-        Main.registerActionShortcut(this,
+        MainApplication.registerActionShortcut(this,
                 Shortcut.registerShortcut("system:copy:cua", tr("Edit: {0}", tr("Copy")), KeyEvent.VK_INSERT, Shortcut.CTRL));
     }
Index: trunk/src/org/openstreetmap/josm/actions/JosmAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/JosmAction.java	(revision 12637)
+++ trunk/src/org/openstreetmap/josm/actions/JosmAction.java	(revision 12639)
@@ -79,5 +79,5 @@
         sc = shortcut;
         if (sc != null && !sc.isAutomatic()) {
-            Main.registerActionShortcut(this, sc);
+            MainApplication.registerActionShortcut(this, sc);
         }
         setTooltip(tooltip);
@@ -218,5 +218,5 @@
     public void destroy() {
         if (sc != null && !sc.isAutomatic()) {
-            Main.unregisterActionShortcut(this);
+            MainApplication.unregisterActionShortcut(this);
         }
         if (layerChangeAdapter != null) {
Index: trunk/src/org/openstreetmap/josm/actions/JumpToAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/JumpToAction.java	(revision 12637)
+++ trunk/src/org/openstreetmap/josm/actions/JumpToAction.java	(revision 12639)
@@ -216,5 +216,5 @@
         super.installAdapters();
         // make this action listen to mapframe change events
-        Main.addMapFrameListener((o, n) -> updateEnabledState());
+        MainApplication.addMapFrameListener((o, n) -> updateEnabledState());
     }
 }
Index: trunk/src/org/openstreetmap/josm/actions/PasteAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/PasteAction.java	(revision 12637)
+++ trunk/src/org/openstreetmap/josm/actions/PasteAction.java	(revision 12639)
@@ -8,5 +8,5 @@
 import java.awt.event.KeyEvent;
 
-import org.openstreetmap.josm.Main;
+import org.openstreetmap.josm.gui.MainApplication;
 import org.openstreetmap.josm.tools.Shortcut;
 
@@ -25,5 +25,5 @@
         putValue("help", ht("/Action/Paste"));
         // CUA shortcut for paste (https://en.wikipedia.org/wiki/IBM_Common_User_Access#Description)
-        Main.registerActionShortcut(this,
+        MainApplication.registerActionShortcut(this,
                 Shortcut.registerShortcut("system:paste:cua", tr("Edit: {0}", tr("Paste")), KeyEvent.VK_INSERT, Shortcut.SHIFT));
     }
Index: trunk/src/org/openstreetmap/josm/actions/SessionSaveAsAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/SessionSaveAsAction.java	(revision 12637)
+++ trunk/src/org/openstreetmap/josm/actions/SessionSaveAsAction.java	(revision 12639)
@@ -75,5 +75,5 @@
                 null, toolbar, "save_as-session", installAdapters);
         putValue("help", ht("/Action/SessionSaveAs"));
-        Main.addMapFrameListener(this);
+        MainApplication.addMapFrameListener(this);
     }
 
Index: trunk/src/org/openstreetmap/josm/actions/ZoomInAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/ZoomInAction.java	(revision 12637)
+++ trunk/src/org/openstreetmap/josm/actions/ZoomInAction.java	(revision 12639)
@@ -8,5 +8,4 @@
 import java.awt.event.KeyEvent;
 
-import org.openstreetmap.josm.Main;
 import org.openstreetmap.josm.gui.MainApplication;
 import org.openstreetmap.josm.tools.Shortcut;
@@ -32,13 +31,13 @@
         putValue("help", ht("/Action/ZoomIn"));
         // On standard QWERTY, AZERTY and other common layouts the '+' key is obtained with Shift+EQUALS
-        Main.registerActionShortcut(this,
+        MainApplication.registerActionShortcut(this,
                 Shortcut.registerShortcut("view:zoominbis", tr("View: {0}", tr("Zoom In")),
                     KeyEvent.VK_EQUALS, Shortcut.SHIFT));
         // But on some systems (Belgian keyboard under Ubuntu) it seems not to work, so use also EQUALS
-        Main.registerActionShortcut(this,
+        MainApplication.registerActionShortcut(this,
                 Shortcut.registerShortcut("view:zoominter", tr("View: {0}", tr("Zoom In")),
                     KeyEvent.VK_EQUALS, Shortcut.DIRECT));
         // make numpad + behave like +
-        Main.registerActionShortcut(this,
+        MainApplication.registerActionShortcut(this,
             Shortcut.registerShortcut("view:zoominkeypad", tr("View: {0}", tr("Zoom In (Keypad)")),
                 KeyEvent.VK_ADD, Shortcut.DIRECT));
Index: trunk/src/org/openstreetmap/josm/actions/ZoomOutAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/ZoomOutAction.java	(revision 12637)
+++ trunk/src/org/openstreetmap/josm/actions/ZoomOutAction.java	(revision 12639)
@@ -8,5 +8,4 @@
 import java.awt.event.KeyEvent;
 
-import org.openstreetmap.josm.Main;
 import org.openstreetmap.josm.gui.MainApplication;
 import org.openstreetmap.josm.tools.Shortcut;
@@ -26,5 +25,5 @@
         putValue("help", ht("/Action/ZoomOut"));
         // make numpad - behave like -
-        Main.registerActionShortcut(this,
+        MainApplication.registerActionShortcut(this,
             Shortcut.registerShortcut("view:zoomoutkeypad", tr("View: {0}", tr("Zoom Out (Keypad)")),
                 KeyEvent.VK_SUBTRACT, Shortcut.DIRECT));
Index: trunk/src/org/openstreetmap/josm/actions/mapmode/DrawAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/mapmode/DrawAction.java	(revision 12637)
+++ trunk/src/org/openstreetmap/josm/actions/mapmode/DrawAction.java	(revision 12639)
@@ -274,5 +274,5 @@
         MapFrame map = MainApplication.getMap();
         map.statusLine.getAnglePanel().addMouseListener(snapHelper.anglePopupListener);
-        Main.registerActionShortcut(backspaceAction, backspaceShortcut);
+        MainApplication.registerActionShortcut(backspaceAction, backspaceShortcut);
 
         map.mapView.addMouseListener(this);
@@ -294,5 +294,5 @@
         map.mapView.removeTemporaryLayer(this);
         SelectionEventManager.getInstance().removeSelectionListener(this);
-        Main.unregisterActionShortcut(backspaceAction, backspaceShortcut);
+        MainApplication.unregisterActionShortcut(backspaceAction, backspaceShortcut);
         snapHelper.unsetFixedMode();
         snapCheckboxMenuItem.getAction().setEnabled(false);
Index: trunk/src/org/openstreetmap/josm/actions/relation/RecentRelationsAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/actions/relation/RecentRelationsAction.java	(revision 12637)
+++ trunk/src/org/openstreetmap/josm/actions/relation/RecentRelationsAction.java	(revision 12639)
@@ -59,5 +59,5 @@
         );
         launchAction = new LaunchEditorAction();
-        Main.registerActionShortcut(launchAction, shortcut);
+        MainApplication.registerActionShortcut(launchAction, shortcut);
     }
 
@@ -115,5 +115,5 @@
     @Override
     public void destroy() {
-        Main.unregisterActionShortcut(launchAction, shortcut);
+        MainApplication.unregisterActionShortcut(launchAction, shortcut);
         super.destroy();
     }